package DX::Op::MemberOf;

use DX::ArrayStream;
use Moo;

with 'DX::Role::Op';

has member_var => (is => 'ro', required => 1);
has coll_name => (is => 'ro', required => 1);

sub run {
  my ($self, $state) = @_;
  my $member = $state->scope_var($self->member_var);
  die "member bound" if $member->is_bound;
  my $set = $state->facts->{$self->coll_name};
  my $stream = DX::ArrayStream->from_array(@{$set}{sort keys %$set});
  return $state->bind_stream_then($member, $stream, $self->next);
}

1;
