package DX::Var;

use Moo;

has id => (is => 'ro', required => 1);

has bound_stream => (is => 'ro');

has bound_value => (is => 'lazy', predicate => 1, clearer => 1, builder => sub {
  $_[0]->bound_stream->next;
});

sub is_bound {
  my ($self) = @_;
  $self->has_bound_value || $self->bound_stream;
}

sub with_stream {
  my ($self, $stream) = @_;
  $self->new(%$self, bound_stream => $stream);
}

sub with_value {
  my ($self, $stream) = @_;
  $self->new(%$self, bound_value => $stream);
}

1;
